	.module Clock.c
	.area vector(rom, abs)
	.org 2
	rjmp _Crossing_interrupt
	.org 6
	rjmp _IR_interrupt
	.org 8
	rjmp _Degre_interrupt
	.org 12
	rjmp _Ticker_interrupt
	.area lit(rom, con, rel)
_table::
	.byte 62,'A
	.byte 'A,'A
	.byte 62,0
	.byte 0,33
	.byte 127,1
	.byte 0,0
	.byte 33,'C
	.byte 'E,'I
	.byte 49,0
	.byte 'B,'A
	.byte 'Q,'i
	.byte 'F,0
	.byte 12,20
	.byte 36,95
	.byte 4,0
	.byte 'r,'Q
	.byte 'Q,'Q
	.byte 'N,0
	.byte 30,41
	.byte 'I,'I
	.byte 6,0
	.byte 64,'G
	.byte 'H,'P
	.byte 96,0
	.byte 54,'I
	.byte 'I,'I
	.byte 54,0
	.byte 48,'I
	.byte 'I,'J
	.byte 60,0
	.byte 0,54
	.byte 54,0
	.byte 0,0
	.byte 0,0
	.byte 0,0
	.byte 0,0
	.dbfile C:\DATA\Clock\Code\Clock.c
	.dbsym e table _table A[72:12:6]c
	.area text(rom, con, rel)
	.dbfile C:\DATA\Clock\Code\Clock.c
	.dbfunc e main _main fV
	.even
_main::
	.dbline -1
	.dbline 89
; //**************************************
; // Clock 16Mhz
; // Version 1.0 Janvier 2002
; // Sylvain Bissonnette
; //**************************************
; 
; //**************************************
; //            I N C L U D E
; //**************************************
; #include <io2313v.h>
; #include <macros.h>
; 
; //**************************************
; //            D E F I N E
; //**************************************
; #define TRUE		0x01
; #define FALSE		0x00
; #define ANALOG		0x01
; #define DIGITAL		0x02
; 
; //**************************************
; //  I N T E R R U P T   H A N D L E R
; //**************************************
; #pragma interrupt_handler Crossing_interrupt:2 
; #pragma interrupt_handler IR_interrupt:4
; #pragma interrupt_handler Degre_interrupt:5 
; #pragma interrupt_handler Ticker_interrupt:7
; 
; //**************************************
; //          P R O T O T Y P E
; //**************************************
; 
; void Crossing_interrupt(void);
; void Degre_interrupt(void);
; void Time(unsigned char);
; void IR_interrupt(void);
; void Ticker_interrupt(void);
; void Display(void);
; void CopyData(int Value);
; void CopyDot(void);
; 
; //**************************************
; //   G L O B A L   V A R I A B L E
; //**************************************
; 
; int WeelPosition;
; unsigned char Pos;
; unsigned int Adder;
; 
; unsigned char LatchedIrData;
; 
; unsigned char Sec;
; unsigned char Min;
; unsigned char Hrs;
; 
; int SecComp;
; int MinComp;
; int HrsComp;
; 
; unsigned char ClockStyle;
; 
; unsigned char TimeString[50];
; unsigned char *TimeStringPtr;
; 
; 
; unsigned char i;
; 
; //**************************************
; //           C O N S T A N T
; //**************************************
; const unsigned char table[12][6] = {{ 0x3e, 0x41, 0x41, 0x41, 0x3e, 0x00 }, // 0	
;   		   					        { 0x00, 0x21, 0x7f, 0x01, 0x00, 0x00  }, // 1 
; 	  		   					    { 0x21, 0x43, 0x45, 0x49, 0x31, 0x00  }, // 2 
; 									{ 0x42, 0x41, 0x51, 0x69, 0x46, 0x00  }, // 3
; 									{ 0x0c, 0x14, 0x24, 0x5f, 0x04, 0x00  }, // 4
; 									{ 0x72, 0x51, 0x51, 0x51, 0x4e, 0x00  }, // 5
; 									{ 0x1e, 0x29, 0x49, 0x49, 0x06, 0x00  }, // 6
; 									{ 0x40, 0x47, 0x48, 0x50, 0x60, 0x00  }, // 7
; 									{ 0x36, 0x49, 0x49, 0x49, 0x36, 0x00  }, // 8
; 									{ 0x30, 0x49, 0x49, 0x4a, 0x3c, 0x00  }, // 9
; 									{ 0x00, 0x36, 0x36, 0x00, 0x00, 0x00  }, // :
; 									{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00  }};// space
; 
; 
; //**************************************
; //            M A I N
; //**************************************
; void main()
; {
	.dbline 90
; WDTCR = 0x0e;			// Enable WatchDog at 0.97 sec
	ldi R24,14
	out 0x21,R24
	.dbline 92
; 		
; PORTD = 0x0d;			// Pull up on PD2&PD3 & Led White ON
	ldi R24,13
	out 0x12,R24
	.dbline 93
; DDRD = 0x03;			// PD0-O PD1-O PD2-I PD3-I PD4-I PD5-I PD6-I PD7-I
	ldi R24,3
	out 0x11,R24
	.dbline 96
; 
; //INT 0
; MCUCR = 0x02;			// Int0 generate int on falling eadge
	ldi R24,2
	out 0x35,R24
	.dbline 97
; GIMSK = 0x40;			// Int0 enable
	ldi R24,64
	out 0x3b,R24
	.dbline 100
; 
; //Timer0
; TCCR0 = 0x05;			// Timer0 / 1024 
	ldi R24,5
	out 0x33,R24
	.dbline 103
; 
; //Timer1
; TCCR1B = 0x42;			// Timer1 / 8 & Input Capture on Rising eadge
	ldi R24,66
	out 0x2e,R24
	.dbline 104
; TIMSK = 0x4a; 			// int enable on Timer1 Compare Match 
	ldi R24,74
	out 0x39,R24
	.dbline 107
; 	  					// int enable on Timer 1 Input Capture
; 						// int enable on Timer0 Overflow
; PORTB = 0x00;			
	clr R2
	out 0x18,R2
	.dbline 108
; DDRB = 0xff;			// PB0-7 as output
	ldi R24,255
	out 0x17,R24
	.dbline 110
; 
; Hrs = 0;
	sts _Hrs,R2
	.dbline 111
; Min = 0;
	sts _Min,R2
	.dbline 112
; Sec = 0;
	sts _Sec,R2
	.dbline 113
; ClockStyle = ANALOG;
	ldi R24,1
	sts _ClockStyle,R24
	.dbline 115
; 
; SEI();
	sei
	rjmp L3
L2:
	.dbline 118
; 
; while(1)
; 	{
	.dbline 119
; 	asm("WDR");
	WDR
	.dbline 120
	clr R2
	sts _i,R2
	rjmp L8
L5:
	.dbline 120
L6:
	.dbline 120
	lds R24,_i
	subi R24,255    ; addi 1
	sts _i,R24
L8:
	.dbline 120
; 	for (i=0;i<200;i++);
	lds R24,_i
	cpi R24,200
	brlo L5
	.dbline 121
	lds R24,_LatchedIrData
	cpi R24,187
	breq L11
	cpi R24,146
	brne L9
L11:
	.dbline 121
; 	if ((LatchedIrData == 0xbb) || (LatchedIrData == 0x92)) Time(TRUE);
	ldi R16,1
	rcall _Time
L9:
	.dbline 122
	lds R24,_LatchedIrData
	cpi R24,179
	breq L14
	cpi R24,176
	brne L12
L14:
	.dbline 122
; 	if ((LatchedIrData == 0xb3) || (LatchedIrData == 0xb0)) ClockStyle = DIGITAL;
	ldi R24,2
	sts _ClockStyle,R24
L12:
	.dbline 123
	lds R24,_LatchedIrData
	cpi R24,180
	breq L17
	cpi R24,177
	brne L15
L17:
	.dbline 123
; 	if ((LatchedIrData == 0xb4) || (LatchedIrData == 0xb1)) ClockStyle = ANALOG;	
	ldi R24,1
	sts _ClockStyle,R24
L15:
	.dbline 125
	clr R2
	sts _LatchedIrData,R2
	.dbline 126
L3:
	.dbline 117
	rjmp L2
X0:
	.dbline -2
	.dbline 127
;    
; 	LatchedIrData = 0;
; 	}
; }
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Time _Time fV
;           Fast -> R20
	.even
_Time::
	rcall push_gset1
	mov R20,R16
	.dbline -1
	.dbline 143
; 
; /**********************************************************
; 
; Name:			void Time(void)
; 
; Description:	
; 
; Input:			none
; 
; Output:			none
; 
; Misc:			
; 
; **********************************************************/	
; void Time(unsigned char Fast)
; {
	.dbline 144
; if (Fast == FALSE) Sec++;
	tst R20
	brne L19
	.dbline 144
	lds R24,_Sec
	subi R24,255    ; addi 1
	sts _Sec,R24
	rjmp L20
L19:
	.dbline 145
; else Sec += 60;
	lds R24,_Sec
	subi R24,196    ; addi 60
	sts _Sec,R24
L20:
	.dbline 146
; if (Sec > 59)
	ldi R24,59
	lds R2,_Sec
	cp R24,R2
	brsh L21
	.dbline 147
;    {
	.dbline 148
;    Sec = 0;
	clr R2
	sts _Sec,R2
	.dbline 149
;    Min++;
	lds R24,_Min
	subi R24,255    ; addi 1
	sts _Min,R24
	.dbline 150
;    if (Min > 59)
	ldi R24,59
	lds R2,_Min
	cp R24,R2
	brsh L23
	.dbline 151
;    	  {
	.dbline 152
; 	  Min = 0;
	clr R2
	sts _Min,R2
	.dbline 153
; 	  Hrs++;
	lds R24,_Hrs
	subi R24,255    ; addi 1
	sts _Hrs,R24
	.dbline 154
; 	  if (Hrs > 11)
	ldi R24,11
	lds R2,_Hrs
	cp R24,R2
	brsh L25
	.dbline 155
; 	  	 {
	.dbline 156
; 		 Hrs = 0;
	clr R2
	sts _Hrs,R2
	.dbline 157
; 		 }
L25:
	.dbline 158
; 	  }
L23:
	.dbline 159
;    }
L21:
	.dbline 161
;   
; if (ClockStyle == ANALOG)
	lds R24,_ClockStyle
	cpi R24,1
	brne L27
	.dbline 162
;    {   
	.dbline 163
;    SecComp = Sec*6;
	lds R18,_Sec
	clr R19
	ldi R16,6
	ldi R17,0
	rcall mpy16s
	sts _SecComp+1,R17
	sts _SecComp,R16
	.dbline 164
;    MinComp = Min*6;
	lds R18,_Min
	clr R19
	ldi R16,6
	ldi R17,0
	rcall mpy16s
	sts _MinComp+1,R17
	sts _MinComp,R16
	.dbline 165
;    HrsComp = (Hrs*30)+(Min/2);
	ldi R18,2
	ldi R19,0
	lds R16,_Min
	clr R17
	rcall div16s
	mov R2,R16
	mov R3,R17
	lds R18,_Hrs
	clr R19
	ldi R16,30
	ldi R17,0
	rcall mpy16s
	mov R4,R16
	mov R5,R17
	add R4,R2
	adc R5,R3
	sts _HrsComp+1,R5
	sts _HrsComp,R4
	.dbline 166
;    }
	rjmp L28
L27:
	.dbline 168
	.dbline 169
	ldi R24,<_TimeString
	ldi R25,>_TimeString
	sts _TimeStringPtr+1,R25
	sts _TimeStringPtr,R24
	.dbline 170
	lds R16,_Hrs
	clr R17
	rcall _CopyData
	.dbline 171
	rcall _CopyDot
	.dbline 172
	lds R16,_Min
	clr R17
	rcall _CopyData
	.dbline 173
	rcall _CopyDot
	.dbline 174
	lds R16,_Sec
	clr R17
	rcall _CopyData
	.dbline 175
L28:
	.dbline -2
	.dbline 176
; else
;    {
;    TimeStringPtr = &TimeString[0];
;    CopyData(Hrs);
;    CopyDot();
;    CopyData(Min);
;    CopyDot();
;    CopyData(Sec);   
;    }
; }
L18:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r Fast 20 c
	.dbend
	.dbfunc e CopyData _CopyData fV
;          Value -> R20,R21
	.even
_CopyData::
	rcall push_gset1
	mov R20,R16
	mov R21,R17
	.dbline -1
	.dbline 193
; 
; /**********************************************************
; 
; Name:			void CopyData(int Value)
; 
; Description:	
; 
; Input:			none
; 
; Output:			none
; 
; Misc:			
; 
; **********************************************************/	
; 
; void CopyData(int Value)
; {
	.dbline 194
; if (Value < 10)
	cpi R20,10
	ldi R30,0
	cpc R21,R30
	brlt X1
	rjmp L30
X1:
	.dbline 195
;    {
	.dbline 196
	clr R2
	sts _i,R2
	rjmp L35
L32:
	.dbline 196
	ldi R24,<_table
	ldi R25,>_table
	lds R2,_i
	clr R3
	add R2,R24
	adc R3,R25
	mov R30,R2
	mov R31,R3
	lpm
	lds R30,_TimeStringPtr
	lds R31,_TimeStringPtr+1
	st Z+,R0
	sts _TimeStringPtr+1,R31
	sts _TimeStringPtr,R30
L33:
	.dbline 196
	lds R24,_i
	subi R24,255    ; addi 1
	sts _i,R24
L35:
	.dbline 196
;    for (i=0;i<6;i++) *TimeStringPtr++ = table[0][i];
	lds R24,_i
	cpi R24,6
	brlo L32
	.dbline 197
	clr R2
	sts _i,R2
	rjmp L39
L36:
	.dbline 197
	ldi R16,6
	ldi R17,0
	mov R18,R20
	mov R19,R21
	rcall mpy16s
	mov R2,R16
	mov R3,R17
	ldi R24,<_table
	ldi R25,>_table
	add R2,R24
	adc R3,R25
	lds R4,_i
	clr R5
	add R4,R2
	adc R5,R3
	mov R30,R4
	mov R31,R5
	lpm
	lds R30,_TimeStringPtr
	lds R31,_TimeStringPtr+1
	st Z+,R0
	sts _TimeStringPtr+1,R31
	sts _TimeStringPtr,R30
L37:
	.dbline 197
	lds R24,_i
	subi R24,255    ; addi 1
	sts _i,R24
L39:
	.dbline 197
;    for (i=0;i<6;i++) *TimeStringPtr++ = table[Value][i];
	lds R24,_i
	cpi R24,6
	brlo L36
	.dbline 198
;    }
	rjmp L31
L30:
	.dbline 200
; else
;    {
	.dbline 201
	clr R2
	sts _i,R2
	rjmp L43
L40:
	.dbline 201
	ldi R18,10
	ldi R19,0
	mov R16,R20
	mov R17,R21
	rcall div16s
	mov R18,R16
	mov R19,R17
	ldi R16,6
	ldi R17,0
	rcall mpy16s
	ldi R24,<_table
	ldi R25,>_table
	mov R2,R16
	mov R3,R17
	add R2,R24
	adc R3,R25
	lds R4,_i
	clr R5
	add R4,R2
	adc R5,R3
	mov R30,R4
	mov R31,R5
	lpm
	lds R30,_TimeStringPtr
	lds R31,_TimeStringPtr+1
	st Z+,R0
	sts _TimeStringPtr+1,R31
	sts _TimeStringPtr,R30
L41:
	.dbline 201
	lds R24,_i
	subi R24,255    ; addi 1
	sts _i,R24
L43:
	.dbline 201
;    for (i=0;i<6;i++) *TimeStringPtr++ = table[Value/10][i];	
	lds R24,_i
	cpi R24,6
	brlo L40
	.dbline 202
	clr R2
	sts _i,R2
	rjmp L47
L44:
	.dbline 202
	ldi R18,10
	ldi R19,0
	mov R16,R20
	mov R17,R21
	rcall div16s
	mov R18,R16
	mov R19,R17
	ldi R16,10
	ldi R17,0
	rcall mpy16s
	mov R18,R20
	mov R19,R21
	sub R18,R16
	sbc R19,R17
	ldi R16,6
	ldi R17,0
	rcall mpy16s
	ldi R24,<_table
	ldi R25,>_table
	mov R2,R16
	mov R3,R17
	add R2,R24
	adc R3,R25
	lds R4,_i
	clr R5
	add R4,R2
	adc R5,R3
	mov R30,R4
	mov R31,R5
	lpm
	lds R30,_TimeStringPtr
	lds R31,_TimeStringPtr+1
	st Z+,R0
	sts _TimeStringPtr+1,R31
	sts _TimeStringPtr,R30
L45:
	.dbline 202
	lds R24,_i
	subi R24,255    ; addi 1
	sts _i,R24
L47:
	.dbline 202
	lds R24,_i
	cpi R24,6
	brlo L44
	.dbline 203
L31:
	.dbline -2
	.dbline 204
;    for (i=0;i<6;i++) *TimeStringPtr++ = table[Value-((Value/10)*10)][i];
;    }	
; }
L29:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r Value 20 I
	.dbend
	.dbfunc e CopyDot _CopyDot fV
	.even
_CopyDot::
	.dbline -1
	.dbline 221
; 
; /**********************************************************
; 
; Name:			void CopySpace(void)
; 
; Description:	
; 
; Input:			none
; 
; Output:			none
; 
; Misc:			
; 
; **********************************************************/	
; 
; void CopyDot(void)
; {
	.dbline 222
	clr R2
	sts _i,R2
	rjmp L52
L49:
	.dbline 222
	ldi R24,<_table+60
	ldi R25,>_table+60
	lds R2,_i
	clr R3
	add R2,R24
	adc R3,R25
	mov R30,R2
	mov R31,R3
	lpm
	lds R30,_TimeStringPtr
	lds R31,_TimeStringPtr+1
	st Z+,R0
	sts _TimeStringPtr+1,R31
	sts _TimeStringPtr,R30
L50:
	.dbline 222
	lds R24,_i
	subi R24,255    ; addi 1
	sts _i,R24
L52:
	.dbline 222
; for (i=0;i<6;i++) *TimeStringPtr++ = table[10][i];
	lds R24,_i
	cpi R24,6
	brlo L49
	.dbline -2
	.dbline 223
; }
L48:
	.dbline 0 ; func end
	ret
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DATA\Clock\Code\Clock.c
L55:
	.blkb 2
L56:
	.blkb 2
L57:
	.blkb 2
L58:
	.blkb 1
	.area text(rom, con, rel)
	.dbfile C:\DATA\Clock\Code\Clock.c
	.dbfunc e Crossing_interrupt _Crossing_interrupt fV
	.dbsym s Lap L58 c
	.dbsym s Latch L57 I
	.dbsym s TotalCount L56 i
	.dbsym s LastCount L55 i
	.even
_Crossing_interrupt::
	rcall push_lset
	.dbline -1
	.dbline 239
; 
; /**********************************************************
; 
; Name:			void Crossing_interrupt(void
; 
; Description:	
; 
; Input:			none
; 
; Output:			none
; 
; Misc:			
; 
; **********************************************************/	
; void Crossing_interrupt(void)
; {
	.dbline 245
; static unsigned int LastCount;
; static unsigned int TotalCount;
; static int Latch;
; static unsigned char Lap;
; 
; Latch = TCNT1;
	in R2,0x2c
	in R3,0x2d
	sts L57+1,R3
	sts L57,R2
	.dbline 246
; TotalCount = Latch - LastCount;
	lds R2,L55
	lds R3,L55+1
	lds R4,L57
	lds R5,L57+1
	sub R4,R2
	sbc R5,R3
	sts L56+1,R5
	sts L56,R4
	.dbline 247
; LastCount = Latch;
	lds R2,L57
	lds R3,L57+1
	sts L55+1,R3
	sts L55,R2
	.dbline 248
; Lap++;
	lds R24,L58
	subi R24,255    ; addi 1
	sts L58,R24
	.dbline 249
; if (Lap > 250)
	ldi R24,250
	lds R2,L58
	cp R24,R2
	brsh L59
	.dbline 250
;    {
	.dbline 251
;    Adder = TotalCount / 378; 
	ldi R18,378
	ldi R19,1
	mov R16,R4
	mov R17,R5
	rcall div16u
	sts _Adder+1,R17
	sts _Adder,R16
	.dbline 252
;    Lap = 0;
	clr R2
	sts L58,R2
	.dbline 253
;    }
L59:
	.dbline 255
;    
; WeelPosition = 0;
	clr R2
	clr R3
	sts _WeelPosition+1,R3
	sts _WeelPosition,R2
	.dbline 256
; OCR1 = Latch + Adder;
	lds R2,_Adder
	lds R3,_Adder+1
	lds R4,L57
	lds R5,L57+1
	add R4,R2
	adc R5,R3
	sts 74+1,R5
	sts 74,R4
	.dbline 257
; TIFR |= 0x80;
	in R24,0x38
	ori R24,128
	out 0x38,R24
	.dbline 258
; Display();
	rcall _Display
	.dbline -2
	.dbline 259
; }
L54:
	rcall pop_lset
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e Degre_interrupt _Degre_interrupt fV
	.even
_Degre_interrupt::
	rcall push_lset
	.dbline -1
	.dbline 275
; 
; /**********************************************************
; 
; Name:			void Degre_interrupt(void)
; 
; Description:	
; 
; Input:			none
; 
; Output:			none
; 
; Misc:			
; 
; **********************************************************/	
; void Degre_interrupt(void)
; {
	.dbline 276
; OCR1 = TCNT1 + Adder;
	lds R2,_Adder
	lds R3,_Adder+1
	in R4,0x2c
	in R5,0x2d
	add R4,R2
	adc R5,R3
	sts 74+1,R5
	sts 74,R4
	.dbline 277
; Display();
	rcall _Display
	.dbline -2
	.dbline 278
; }
L61:
	rcall pop_lset
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e Display _Display fV
	.even
_Display::
	.dbline -1
	.dbline 295
; 
; /**********************************************************
; 
; Name:			void Display(void)
; 
; Description:	
; 
; Input:			none
; 
; Output:			none
; 
; Misc:			
; 
; **********************************************************/	
; 
; void Display(void)
; {
	.dbline 296
; PORTB = 0x00;
	clr R2
	out 0x18,R2
	.dbline 298
; 
; if (ClockStyle == ANALOG)
	lds R24,_ClockStyle
	cpi R24,1
	breq X3
	rjmp L63
X3:
	.dbline 299
;    {
	.dbline 300
;    if (WeelPosition == HrsComp) PORTB = 0x80;
	lds R2,_HrsComp
	lds R3,_HrsComp+1
	lds R4,_WeelPosition
	lds R5,_WeelPosition+1
	cp R4,R2
	cpc R5,R3
	brne L65
	.dbline 300
	ldi R24,128
	out 0x18,R24
L65:
	.dbline 301
;    if (WeelPosition == MinComp) PORTB = 0xff;
	lds R2,_MinComp
	lds R3,_MinComp+1
	lds R4,_WeelPosition
	lds R5,_WeelPosition+1
	cp R4,R2
	cpc R5,R3
	brne L67
	.dbline 301
	ldi R24,255
	out 0x18,R24
L67:
	.dbline 302
;    if (WeelPosition == SecComp) PORTB |= 0x03;
	lds R2,_SecComp
	lds R3,_SecComp+1
	lds R4,_WeelPosition
	lds R5,_WeelPosition+1
	cp R4,R2
	cpc R5,R3
	brne L69
	.dbline 302
	in R24,0x18
	ori R24,3
	out 0x18,R24
L69:
	.dbline 304
; 
;    if ((WeelPosition == 0) ||
	lds R2,_WeelPosition
	lds R3,_WeelPosition+1
	tst R2
	brne X2
	tst R3
	breq L83
X2:
	lds R24,_WeelPosition
	lds R25,_WeelPosition+1
	cpi R24,30
	ldi R30,0
	cpc R25,R30
	breq L83
	cpi R24,60
	ldi R30,0
	cpc R25,R30
	breq L83
	cpi R24,90
	ldi R30,0
	cpc R25,R30
	breq L83
	cpi R24,120
	ldi R30,0
	cpc R25,R30
	breq L83
	cpi R24,150
	ldi R30,0
	cpc R25,R30
	breq L83
	cpi R24,180
	ldi R30,0
	cpc R25,R30
	breq L83
	cpi R24,210
	ldi R30,0
	cpc R25,R30
	breq L83
	cpi R24,240
	ldi R30,0
	cpc R25,R30
	breq L83
	cpi R24,14
	ldi R30,1
	cpc R25,R30
	breq L83
	cpi R24,44
	ldi R30,1
	cpc R25,R30
	breq L83
	cpi R24,74
	ldi R30,1
	cpc R25,R30
	brne L64
L83:
	.dbline 315
;       (WeelPosition == 30) ||
; 	  (WeelPosition == 60) ||
; 	  (WeelPosition == 90) ||
; 	  (WeelPosition == 120) ||
; 	  (WeelPosition == 150) ||
; 	  (WeelPosition == 180) ||
; 	  (WeelPosition == 210) ||
; 	  (WeelPosition == 240) ||
; 	  (WeelPosition == 270) ||
; 	  (WeelPosition == 300) ||
; 	  (WeelPosition == 330)) PORTB |= 0x01;
	sbi 0x18,0
	.dbline 316
;    }
	rjmp L64
L63:
	.dbline 318
; else  
;    {
	.dbline 319
;    Pos = ((WeelPosition-100) / 3);
	ldi R18,3
	ldi R19,0
	lds R16,_WeelPosition
	lds R17,_WeelPosition+1
	subi R16,100
	sbci R17,0
	rcall div16s
	sts _Pos,R16
	.dbline 320
;    if (Pos < 49)
	cpi R16,49
	brsh L84
	.dbline 321
;    	  {
	.dbline 322
; 	  PORTB = TimeString[48-Pos];
	mov R2,R16
	clr R3
	ldi R30,48
	ldi R31,0
	sub R30,R2
	sbc R31,R3
	ldi R24,<_TimeString
	ldi R25,>_TimeString
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	out 0x18,R2
	.dbline 323
; 	  }
L84:
	.dbline 324
;    }
L64:
	.dbline 325
; WeelPosition++;
	lds R24,_WeelPosition
	lds R25,_WeelPosition+1
	adiw R24,1
	sts _WeelPosition+1,R25
	sts _WeelPosition,R24
	.dbline -2
	.dbline 326
; }
L62:
	.dbline 0 ; func end
	ret
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DATA\Clock\Code\Clock.c
L87:
	.blkb 2
L88:
	.blkb 2
L89:
	.blkb 2
	.area text(rom, con, rel)
	.dbfile C:\DATA\Clock\Code\Clock.c
	.dbfunc e IR_interrupt _IR_interrupt fV
	.dbsym s IrData L89 i
	.dbsym s IrPulseCount L88 i
	.dbsym s LastCapture L87 i
;     PulseWidth -> R16,R17
	.even
_IR_interrupt::
	st -y,R2
	st -y,R3
	st -y,R16
	st -y,R17
	st -y,R24
	st -y,R25
	st -y,R30
	in R2,0x3f
	st -y,R2
	.dbline -1
	.dbline 353
; 
; /**********************************************************
; 
; Name:			void IR_interrupt(void)
; 
; Description:	This routine is called whenever a rising edge (beginning
;                 of valid IR signal) is received.
; 
;                 - The data codes are sent using pulse coding.
;                 - Each packet has 12 bits and a header.
;                 - The basic time period T = 550us.
;                 - The header length = 4T (2.2ms)
;                 - 0 = pulse with length T followed by space of length T.
;                 - 1 = pulse with length 2T followed by space of length T.
;                 - The last 5 bits represent the Addess.
;                 - The first 7 bits represent the command.
;                 - A packet is transmitted every 25ms while a button is down.
; 
; Input:			none		
; 
; Output:			Global variable LatchedIrData
; 
; Misc:			Sony VCR protocol
; 
; **********************************************************/	
; void IR_interrupt(void)
; {
	.dbline 359
; static unsigned int LastCapture;
; unsigned int PulseWidth;
; static unsigned int IrPulseCount;
; static unsigned int IrData;
; 
; PulseWidth = ICR1 - LastCapture;
	lds R2,L87
	lds R3,L87+1
	in R16,0x24
	in R17,0x25
	sub R16,R2
	sbc R17,R3
	.dbline 360
; LastCapture = ICR1;
	in R2,0x24
	in R3,0x25
	sts L87+1,R3
	sts L87,R2
	.dbline 363
; 
; 
; if (PulseWidth > 4000) 
	ldi R24,4000
	ldi R25,15
	cp R24,R16
	cpc R25,R17
	brsh L90
	.dbline 364
;    {
	.dbline 365
;    IrPulseCount = 0;
	clr R2
	clr R3
	sts L88+1,R3
	sts L88,R2
	.dbline 366
;    IrData = 0;
	sts L89+1,R3
	sts L89,R2
	.dbline 367
;    }
	rjmp L91
L90:
	.dbline 369
; else
;    {
	.dbline 370
;    IrData = IrData >> 1;
	lds R2,L89
	lds R3,L89+1
	lsr R3
	ror R2
	sts L89+1,R3
	sts L89,R2
	.dbline 371
;    if (PulseWidth > 2800) IrData = IrData | 0x8000;
	ldi R24,2800
	ldi R25,10
	cp R24,R16
	cpc R25,R17
	brsh L92
	.dbline 371
	mov R24,R2
	mov R25,R3
	ori R25,128
	sts L89+1,R25
	sts L89,R24
L92:
	.dbline 372
;    IrPulseCount++;
	lds R24,L88
	lds R25,L88+1
	adiw R24,1
	sts L88+1,R25
	sts L88,R24
	.dbline 373
;    if (IrPulseCount == 12) LatchedIrData = ((IrData >> 4) & 0x00ff);
	cpi R24,12
	ldi R30,0
	cpc R25,R30
	brne L94
	.dbline 373
	lds R24,L89
	lds R25,L89+1
	lsr R25
	ror R24
	lsr R25
	ror R24
	lsr R25
	ror R24
	lsr R25
	ror R24
	andi R25,0
	sts _LatchedIrData,R24
L94:
	.dbline 374
L91:
	.dbline -2
	.dbline 375
;    }
; }
L86:
	ld R2,y+
	out 0x3f,R2
	ld R30,y+
	ld R25,y+
	ld R24,y+
	ld R17,y+
	ld R16,y+
	ld R3,y+
	ld R2,y+
	.dbline 0 ; func end
	reti
	.dbsym r PulseWidth 16 i
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DATA\Clock\Code\Clock.c
L97:
	.blkb 1
	.area text(rom, con, rel)
	.dbfile C:\DATA\Clock\Code\Clock.c
	.dbfunc e Ticker_interrupt _Ticker_interrupt fV
	.dbsym s Tick L97 c
	.even
_Ticker_interrupt::
	rcall push_lset
	.dbline -1
	.dbline 391
; 
; /**********************************************************
; 
; Name:			void Ticker_interrupt(void)
; 
; Description:	
; 
; Input:			none
; 
; Output:			none
; 
; Misc:			
; 
; **********************************************************/	
; void Ticker_interrupt(void)
; {
	.dbline 393
; static unsigned char Tick;
; Tick++;
	lds R24,L97
	subi R24,255    ; addi 1
	sts L97,R24
	.dbline 394
; if (Tick > 62)
	ldi R24,62
	lds R2,L97
	cp R24,R2
	brsh L98
	.dbline 395
;    {
	.dbline 396
;    Time(FALSE);
	clr R16
	rcall _Time
	.dbline 397
;    Tick = 0;
	clr R2
	sts L97,R2
	.dbline 398
;    }
L98:
	.dbline 399
; TCNT0 = 0x04; // reload counter
	ldi R24,4
	out 0x32,R24
	.dbline -2
	.dbline 400
; }
L96:
	rcall pop_lset
	.dbline 0 ; func end
	reti
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DATA\Clock\Code\Clock.c
_i::
	.blkb 1
	.dbsym e i _i c
_TimeStringPtr::
	.blkb 2
	.dbsym e TimeStringPtr _TimeStringPtr pc
_TimeString::
	.blkb 50
	.dbsym e TimeString _TimeString A[50:50]c
_ClockStyle::
	.blkb 1
	.dbsym e ClockStyle _ClockStyle c
_HrsComp::
	.blkb 2
	.dbsym e HrsComp _HrsComp I
_MinComp::
	.blkb 2
	.dbsym e MinComp _MinComp I
_SecComp::
	.blkb 2
	.dbsym e SecComp _SecComp I
_Hrs::
	.blkb 1
	.dbsym e Hrs _Hrs c
_Min::
	.blkb 1
	.dbsym e Min _Min c
_Sec::
	.blkb 1
	.dbsym e Sec _Sec c
_LatchedIrData::
	.blkb 1
	.dbsym e LatchedIrData _LatchedIrData c
_Adder::
	.blkb 2
	.dbsym e Adder _Adder i
_Pos::
	.blkb 1
	.dbsym e Pos _Pos c
_WeelPosition::
	.blkb 2
	.dbsym e WeelPosition _WeelPosition I
